package com.company.restunique.rest;

import io.jmix.data.exception.UniqueConstraintViolationException;
import io.jmix.rest.impl.controller.ErrorInfo;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.core.annotation.Order;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;

@ControllerAdvice("io.jmix.rest.impl.controller")
@Order(0)
public class MyRestControllerExceptionHandler {

    private static final Logger log = LoggerFactory.getLogger(MyRestControllerExceptionHandler.class);

    @ExceptionHandler(UniqueConstraintViolationException.class)
    @ResponseBody
    public ResponseEntity<ErrorInfo> handleUniqueConstraintViolationException(UniqueConstraintViolationException e) {
        log.info("UniqueConstraintViolationException: {}", e.getConstraintName(), e);
        ErrorInfo errorInfo = new ErrorInfo("Unique constraint violation", e.getConstraintName());
        return new ResponseEntity<>(errorInfo, HttpStatus.CONFLICT);
    }
}